Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gradle
[Java] Class StartParameter

    java.lang.Object
      org.gradle.logging.LoggingConfiguration
          org.gradle.StartParameter

All Implemented Interfaces:
  Serializable

    public class StartParameter
    extends LoggingConfiguration

`StartParameter` defines the configuration used by a Gradle instance to execute a build. The properties of `StartParameter` generally correspond to the command-line options of Gradle.

You pass a `StartParameter` instance to GradleLauncher#newInstance(StartParameter)#newInstance(StartParameter) when you create a new Gradle instance.

You can obtain an instance of a `StartParameter` by either creating a new one, or duplicating an existing one using newInstance or newBuild.

See Also:
  GradleLauncher

Field Summary
`static File` | `DEFAULT_GRADLE_USER_HOME` The default user home directory.
`static String` | `GRADLE_USER_HOME_PROPERTY_KEY`

Constructor Summary
`StartParameter()` Creates a `StartParameter` with default values.

Method Summary
`void` | `addInitScript(File initScriptFile)` Adds the given file to the list of init scripts that are run before the build starts.
`boolean` | `equals(Object obj)`
`List` | `getAllInitScripts()` Returns all init scripts, including explicit init scripts and implicit init scripts.
`File` | `getBuildFile()` Returns the build file to use to select the default project.
`CacheUsage` | `getCacheUsage()` Returns the configured CacheUsage.
`File` | `getCurrentDir()` Returns the directory to use to select the default project, and to search for the settings file.
`Set` | `getExcludedTaskNames()` Returns the names of the tasks to be excluded from this build.
`File` | `getGradleUserHomeDir()` Returns the directory to use as the user home directory.
`List` | `getInitScripts()` Returns all explicitly added init scripts that will be run before the build starts.
`Map` | `getMergedSystemProperties()` Deprecated.
`int` | `getParallelThreadCount()` Returns the number of parallel threads to use for build execution.
`File` | `getProjectCacheDir()` Returns the project's cache dir.
`File` | `getProjectDir()` Returns the project dir to use to select the default project.
`Map` | `getProjectProperties()`
`RefreshOptions` | `getRefreshOptions()` Returns the refresh options used for the build.
`File` | `getSettingsFile()` Returns the explicit settings file to use for the build, or null.
`Map` | `getSystemPropertiesArgs()`
`List` | `getTaskNames()` Returns the names of the tasks to execute in this build.
`int` | `hashCode()`
`boolean` | `isBuildProjectDependencies()` Returns true if project dependencies are to be built, false if they should not be.
`boolean` | `isConfigureOnDemand()` If the configure-on-demand mode is active
`boolean` | `isContinueOnFailure()` Specifies whether the build should continue on task failure.
`boolean` | `isDryRun()`
`boolean` | `isNoOpt()` Returns task optimization disabled flag.
`boolean` | `isOffline()` Specifies whether the build should be performed offline (ie without network access).
`boolean` | `isProfile()` Returns true if a profile report will be generated.
`boolean` | `isRecompileScripts()` Specifies whether the build scripts should be recompiled.
`boolean` | `isRefreshDependencies()` Specifies whether the dependencies should be refreshed..
`boolean` | `isRerunTasks()` Specifies whether the cached task results should be ignored and each task should be forced to be executed.
`boolean` | `isSearchUpwards()`
`boolean` | `isUseEmptySettings()` Returns whether an empty settings script will be used regardless of whether one exists in the default location.
`StartParameter` | `newBuild()`
`StartParameter` | `newInstance()` Duplicates this `StartParameter` instance.
`protected StartParameter` | `prepareNewBuild(StartParameter p)`
`protected StartParameter` | `prepareNewInstance(StartParameter p)`
`void` | `setBuildFile(File buildFile)` Sets the build file to use to select the default project.
`StartParameter` | `setBuildProjectDependencies(boolean build)` Specifies whether project dependencies should be built.
`void` | `setCacheUsage(CacheUsage cacheUsage)` Sets the Cache usage.
`void` | `setConfigureOnDemand(boolean configureOnDemand)`
`void` | `setContinueOnFailure(boolean continueOnFailure)` Specifies whether the build should continue on task failure.
`void` | `setCurrentDir(File currentDir)` Sets the directory to use to select the default project, and to search for the settings file.
`void` | `setDryRun(boolean dryRun)`
`void` | `setExcludedTaskNames(Iterable excludedTaskNames)` Sets the tasks to exclude from this build.
`void` | `setGradleUserHomeDir(File gradleUserHomeDir)` Sets the directory to use as the user home directory.
`void` | `setInitScripts(List initScripts)` Sets the list of init scripts to be run before the build starts.
`void` | `setNoOpt(boolean noOpt)` Get task optimization disabled.
`void` | `setOffline(boolean offline)` Specifies whether the build should be performed offline (ie without network access).
`void` | `setParallelThreadCount(int parallelThreadCount)` Specifies the number of parallel threads to use for build execution.
`void` | `setProfile(boolean profile)` Specifies if a profile report should be generated.
`void` | `setProjectCacheDir(File projectCacheDir)` Sets the project's cache location.
`void` | `setProjectDir(File projectDir)` Sets the project directory to use to select the default project.
`void` | `setProjectProperties(Map projectProperties)`
`void` | `setRecompileScripts(boolean recompileScripts)` Specifies whether the build scripts should be recompiled.
`void` | `setRefreshDependencies(boolean refreshDependencies)` Specifies whether the dependencies should be refreshed..
`void` | `setRefreshOptions(RefreshOptions refreshOptions)` Supplies the refresh options to use for the build.
`void` | `setRerunTasks(boolean rerunTasks)` Specifies whether the cached task results should be ignored and each task should be forced to be executed.
`void` | `setSearchUpwards(boolean searchUpwards)`
`void` | `setSettingsFile(File settingsFile)` Sets the settings file to use for the build.
`void` | `setSystemPropertiesArgs(Map systemPropertiesArgs)`
`void` | `setTaskNames(Iterable taskNames)`
`String` | `toString()`
`StartParameter` | `useEmptySettings()` Specifies that an empty settings script should be used.
`StartParameter` | `useEmptySettingsScript()` Deprecated.

Field Detail

### DEFAULT_GRADLE_USER_HOME

    public static final File DEFAULT_GRADLE_USER_HOME

  The default user home directory.

### GRADLE_USER_HOME_PROPERTY_KEY

    public static final String GRADLE_USER_HOME_PROPERTY_KEY

Constructor Detail

### StartParameter

    public StartParameter()

  Creates a `StartParameter` with default values. This is roughly equivalent to running Gradle on the command-line with no arguments.

Method Detail

### addInitScript

    public void addInitScript(File initScriptFile)

  Adds the given file to the list of init scripts that are run before the build starts. This list is in addition to the default init scripts.
  Parameters:
    `initScriptFile` - The init scripts.

### equals

    public boolean equals(Object obj)

### getAllInitScripts

    @Incubating
    public List getAllInitScripts()

  Returns all init scripts, including explicit init scripts and implicit init scripts.
  Returns:
    All init scripts, including explicit init scripts and implicit init scripts.

### getBuildFile

    public File getBuildFile()

  Returns the build file to use to select the default project. Returns null when the build file is not used to select the default project.
  Returns:
    The build file. May be null.

### getCacheUsage

    @Deprecated
    public CacheUsage getCacheUsage()

  Returns the configured CacheUsage.
  deprecated:
    Use isRecompileScripts and/or isRerunTasks instead.

### getCurrentDir

    public File getCurrentDir()

  Returns the directory to use to select the default project, and to search for the settings file.
  Returns:
    The current directory. Never returns null.

### getExcludedTaskNames

    public Set getExcludedTaskNames()

  Returns the names of the tasks to be excluded from this build. When empty, no tasks are excluded from the build.
  Returns:
    The names of the excluded tasks. Returns an empty set if there are no such tasks.

### getGradleUserHomeDir

    public File getGradleUserHomeDir()

  Returns the directory to use as the user home directory.
  Returns:
    The home directory.

### getInitScripts

    public List getInitScripts()

  Returns all explicitly added init scripts that will be run before the build starts. This list does not contain the user init script located in ${user.home}/.gradle/init.gradle, even though that init script will also be run.
  Returns:
    list of all explicitly added init scripts.

### getMergedSystemProperties

    @Deprecated
    public Map getMergedSystemProperties()

  Deprecated. It is no longer used internally and there's no good reason to keep it. There is no replacement method. Returns a newly constructed map that is the JVM system properties merged with the system property args.

  System property args take precedence over JVM system properties.

  deprecated:
    No replacement
  Returns:
    The merged system properties

### getParallelThreadCount

    public int getParallelThreadCount()

  Returns the number of parallel threads to use for build execution. <0: Automatically determine the optimal number of executors to use. 0: Do not use parallel execution. >0: Use this many parallel execution threads.

### getProjectCacheDir

    public File getProjectCacheDir()

  Returns the project's cache dir.
  Returns:
    project's cache dir, or null if the default location is to be used.

### getProjectDir

    public File getProjectDir()

  Returns the project dir to use to select the default project. Returns null when the build file is not used to select the default project
  Returns:
    The project dir. May be null.

### getProjectProperties

    public Map getProjectProperties()

### getRefreshOptions

    @Deprecated
    public RefreshOptions getRefreshOptions()

  Returns the refresh options used for the build.
  deprecated:
    Use isRefreshDependencies() instead.

### getSettingsFile

    public File getSettingsFile()

  Returns the explicit settings file to use for the build, or null. Will return null if the default settings file is to be used. However, if isUseEmptySettings() returns true, then no settings file at all will be used.
  Returns:
    The settings file. May be null.
  See Also:
    isUseEmptySettings()

### getSystemPropertiesArgs

    public Map getSystemPropertiesArgs()

### getTaskNames

    public List getTaskNames()

  Returns the names of the tasks to execute in this build. When empty, the default tasks for the project will be executed.
  Returns:
    the names of the tasks to execute in this build. Never returns null.

### hashCode

    public int hashCode()

### isBuildProjectDependencies

    public boolean isBuildProjectDependencies()

  Returns true if project dependencies are to be built, false if they should not be. The default is true.

### isConfigureOnDemand

    @Incubating
    public boolean isConfigureOnDemand()

  If the configure-on-demand mode is active

### isContinueOnFailure

    public boolean isContinueOnFailure()

  Specifies whether the build should continue on task failure. The default is false.

### isDryRun

    public boolean isDryRun()

### isNoOpt

    @Deprecated
    public boolean isNoOpt()

  Returns task optimization disabled flag.
  deprecated:
    Use isRerunTasks instead.

### isOffline

    public boolean isOffline()

  Specifies whether the build should be performed offline (ie without network access).

### isProfile

    public boolean isProfile()

  Returns true if a profile report will be generated.

### isRecompileScripts

    public boolean isRecompileScripts()

  Specifies whether the build scripts should be recompiled.

### isRefreshDependencies

    public boolean isRefreshDependencies()

  Specifies whether the dependencies should be refreshed..

### isRerunTasks

    public boolean isRerunTasks()

  Specifies whether the cached task results should be ignored and each task should be forced to be executed.

### isSearchUpwards

    public boolean isSearchUpwards()

### isUseEmptySettings

    public boolean isUseEmptySettings()

  Returns whether an empty settings script will be used regardless of whether one exists in the default location.
  Returns:
    Whether to use empty settings or not.

### newBuild

    public StartParameter newBuild()

  Creates the parameters for a new build, using these parameters as a template. Copies the environmental properties from this parameter (eg Gradle user home dir, etc), but does not copy the build specific properties (eg task names).

  Returns:
    The new parameters.

### newInstance

    public StartParameter newInstance()

  Duplicates this `StartParameter` instance.
  Returns:
    the new parameters.

### prepareNewBuild

    protected StartParameter prepareNewBuild(StartParameter p)

### prepareNewInstance

    protected StartParameter prepareNewInstance(StartParameter p)

### setBuildFile

    public void setBuildFile(File buildFile)

  Sets the build file to use to select the default project. Use null to disable selecting the default project using the build file.
  Parameters:
    `buildFile` - The build file. May be null.

### setBuildProjectDependencies

    public StartParameter setBuildProjectDependencies(boolean build)

  Specifies whether project dependencies should be built. Defaults to true.
  Returns:
    this

### setCacheUsage

    @Deprecated
    public void setCacheUsage(CacheUsage cacheUsage)

  Sets the Cache usage.
  deprecated:
    Use setRecompileScripts and/or setRerunTasks instead.

### setConfigureOnDemand

    @Incubating
    public void setConfigureOnDemand(boolean configureOnDemand)

### setContinueOnFailure

    public void setContinueOnFailure(boolean continueOnFailure)

  Specifies whether the build should continue on task failure. The default is false.

### setCurrentDir

    public void setCurrentDir(File currentDir)

  Sets the directory to use to select the default project, and to search for the settings file. Set to null to use the default current directory.
  Parameters:
    `currentDir` - The directory. Set to null to use the default.

### setDryRun

    public void setDryRun(boolean dryRun)

### setExcludedTaskNames

    public void setExcludedTaskNames(Iterable excludedTaskNames)

  Sets the tasks to exclude from this build.
  Parameters:
    `excludedTaskNames` - The task names. Can be null.

### setGradleUserHomeDir

    public void setGradleUserHomeDir(File gradleUserHomeDir)

  Sets the directory to use as the user home directory. Set to null to use the default directory.
  Parameters:
    `gradleUserHomeDir` - The home directory. May be null.

### setInitScripts

    public void setInitScripts(List initScripts)

  Sets the list of init scripts to be run before the build starts. This list is in addition to the default init scripts.
  Parameters:
    `initScripts` - The init scripts.

### setNoOpt

    @Deprecated
    public void setNoOpt(boolean noOpt)

  Get task optimization disabled.
  deprecated:
    Use setRerunTasks(boolean) instead.
  Parameters:
    `noOpt` - The boolean value for disabling task optimization.

### setOffline

    public void setOffline(boolean offline)

  Specifies whether the build should be performed offline (ie without network access).

### setParallelThreadCount

    public void setParallelThreadCount(int parallelThreadCount)

  Specifies the number of parallel threads to use for build execution.
  See Also:
    getParallelThreadCount()

### setProfile

    public void setProfile(boolean profile)

  Specifies if a profile report should be generated.
  Parameters:
    `profile` - true if a profile report should be generated

### setProjectCacheDir

    public void setProjectCacheDir(File projectCacheDir)

  Sets the project's cache location. Set to null to use the default location.

### setProjectDir

    public void setProjectDir(File projectDir)

  Sets the project directory to use to select the default project. Use null to use the default criteria for selecting the default project.
  Parameters:
    `projectDir` - The project directory. May be null.

### setProjectProperties

    public void setProjectProperties(Map projectProperties)

### setRecompileScripts

    public void setRecompileScripts(boolean recompileScripts)

  Specifies whether the build scripts should be recompiled.

### setRefreshDependencies

    public void setRefreshDependencies(boolean refreshDependencies)

  Specifies whether the dependencies should be refreshed..

### setRefreshOptions

    @Deprecated
    public void setRefreshOptions(RefreshOptions refreshOptions)

  Supplies the refresh options to use for the build.
  deprecated:
    Use setRefreshDependencies(boolean) instead.

### setRerunTasks

    public void setRerunTasks(boolean rerunTasks)

  Specifies whether the cached task results should be ignored and each task should be forced to be executed.

### setSearchUpwards

    public void setSearchUpwards(boolean searchUpwards)

### setSettingsFile

    public void setSettingsFile(File settingsFile)

  Sets the settings file to use for the build. Use null to use the default settings file.
  Parameters:
    `settingsFile` - The settings file to use. May be null.

### setSystemPropertiesArgs

    public void setSystemPropertiesArgs(Map systemPropertiesArgs)

### setTaskNames

    public void setTaskNames(Iterable taskNames)

  Sets the tasks to execute in this build. Set to an empty list, or null, to execute the default tasks for the project. The tasks are executed in the order provided, subject to dependency between the tasks.

  Parameters:
    `taskNames` - the names of the tasks to execute in this build.

### toString

    @Override
    public String toString()

### useEmptySettings

    public StartParameter useEmptySettings()

  Specifies that an empty settings script should be used. This means that even if a settings file exists in the conventional location, or has been previously specified by setSettingsFile(java.io.File), it will not be used. If setSettingsFile(java.io.File) is called after this, it will supersede calling this method.
  Returns:
    this

### useEmptySettingsScript

    @Deprecated
    public StartParameter useEmptySettingsScript()

  Deprecated. Use useEmptySettings().
  deprecated:
    use useEmptySettings()

Gradle API 1.10